indexing
	description: "This texture object allows you to render into it"
	date: "$Date: Jul 11, 2006 9:36:39 PM$"
	revision: "$Revision: 1.0$"

class EM3D_RENDER_TEXTURE_2D[F -> EMGL_FORMAT create default_create end]

inherit
	EM3D_TEXTURE_2D[F]
		redefine
			make_empty
		end

	EM_CONSTANTS
		export {NONE} all
		undefine default_create end

	GLEXT_FUNCTIONS_EXTERNAL
		export {NONE} all
		undefine default_create end

	GLEW_FUNCTIONS
		export {NONE} all {ANY} is_supported
		undefine default_create end

	EMGLU_FUNCTIONS
		export {NONE} all
		undefine default_create end

	EM_SHARED_SUBSYSTEMS
		export {NONE} all
		undefine default_create end

create
	make_empty, make_empty_mipmap

feature {NONE} -- Initialization
	make_empty( width, height: INTEGER ) is
			-- Make the texture for RenderToTexture
		local
			dims: ARRAY[ INTEGER ]
			tmp: ANY
		do
			Precursor(width, height)
			-- Ati Fix, undo this on a normal graka
			if is_supported( "GL_EXT_framebuffer_object" ) then
				init_render_to_texture_fbo( width, height )
			else
				-- Check width and height of the backbuffer
				create dims.make(1,2)
				tmp := dims.to_c
				gl_get_integerv_external ( em_gl_max_viewport_dims, $tmp )
				if width>dims[1] or height>dims[2] then
					Error_handler.raise_warning (Error_codes.Em_error_em3d_texture, ["Texture size exceeds maximal backbuffer size!"])
				end

				if width>video_subsystem.video_surface_width or height>video_subsystem.video_surface_height then
					Error_handler.raise_warning (Error_codes.Em_error_em3d_texture, ["Texture size exceeds backbuffer size!"])
				end
			end

		end

	init_render_to_texture_fbo( width, height: INTEGER ) is
			-- Init the fbo
		require
			extension_is_avialbe: em_gl_ext_framebuffer_object > 0
		local
			err:INTEGER
		do
			if em_gl_ext_framebuffer_object<=0 then
				Error_handler.raise_error (Error_codes.Em_error_em3d_texture, ["Empty mipmap: framebuffer objects not supported!"])
			end

			create current_fbo
			attach_to_framebuffer( em_gl_color_attachment0_ext, current_fbo)

			create depth_buffer.make( em_gl_depth_component24, width, height )
			depth_buffer.attach_to_framebuffer( em_gl_depth_attachment_ext, current_fbo )

			if current_fbo.check_status /= em_gl_framebuffer_complete_ext then
				from err := gl_get_error_external until err=0 loop
					Error_handler.raise_warning (Error_codes.Em_error_em3d_texture, ["OpenGL Error: "+emglu_error_string( err )+"%N"])
					err := gl_get_error_external
				end
			end
		ensure
			valid_current_fbo: current_fbo/=void
		end

feature {EM3D_TEXTURE_2D} -- RenderToTexture
	current_fbo: EMGL_FRAME_BUFFER
	depth_buffer: EMGL_RENDER_BUFFER
	old_draw_buffer: INTEGER

feature -- RenderToTexture
	begin_render_to_texture is
			-- Start render to texture. Init the framebuffer, and bind the texture to it
		do
			if current_fbo/= void then
				current_fbo.bind
			else
				old_draw_buffer := emgl_get_integer ( em_gl_draw_buffer )
				gl_draw_buffer_external ( em_gl_back )
			end

			gl_push_attrib_external ( em_gl_viewport_bit )
			gl_viewport_external ( 0, 0, texture_width, texture_height )
		end
	end_render_to_texture is
			-- Start render to texture. Init the framebuffer, and bind the texture to it
		do
			gl_pop_attrib_external
			if current_fbo/=void then
				current_fbo.unbind
			else
				gl_draw_buffer_external( old_draw_buffer )
				gl_read_buffer_external( em_gl_back )
				copy_tex_sub_image2d ( 0, 0, 0, 0, 0, texture_width, texture_height)
			end
			if is_mipmap then
				generate_mipmap
			end
		end

end -- class EM3D_RENDER_TEXTURE_2D
